'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _helpers = require('./helpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
	Input_missing: custom_error('Missing input', { status: 400 }),
	Unauthenticated: custom_error('Unauthenticated', { status: 401 }),
	Unauthorized: custom_error('Unauthorized', { status: 403 }),
	Access_denied: custom_error('Access denied', { status: 403 }),
	Not_found: custom_error('Not found', { status: 404 }),
	Conflict: custom_error('Conflict', { status: 409 }),
	Unsupported_input_type: custom_error('Unsupported input type', { status: 415 }),
	Input_rejected: custom_error('Input rejected', { status: 422 }),
	Error: custom_error('Server error', { status: 500 })
};


function custom_error(name, default_properties) {
	var Custom_error = function (_Error) {
		(0, _inherits3.default)(Custom_error, _Error);

		function Custom_error(message, properties) {
			(0, _classCallCheck3.default)(this, Custom_error);

			var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Custom_error).call(this));

			if ((0, _helpers.is_object)(message)) {
				properties = message;
				message = undefined;
			}

			var _iteratorNormalCompletion = true;
			var _didIteratorError = false;
			var _iteratorError = undefined;

			try {
				for (var _iterator = (0, _getIterator3.default)((0, _keys2.default)(default_properties)), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
					var _key = _step.value;

					_this[_key] = default_properties[_key];
				}
			} catch (err) {
				_didIteratorError = true;
				_iteratorError = err;
			} finally {
				try {
					if (!_iteratorNormalCompletion && _iterator.return) {
						_iterator.return();
					}
				} finally {
					if (_didIteratorError) {
						throw _iteratorError;
					}
				}
			}

			_this.name = name;
			_this.message = name;

			if (message) {
				_this.message = message;
			}

			if ((0, _helpers.exists)(properties)) {
				var _iteratorNormalCompletion2 = true;
				var _didIteratorError2 = false;
				var _iteratorError2 = undefined;

				try {
					for (var _iterator2 = (0, _getIterator3.default)((0, _keys2.default)(properties)), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
						var key = _step2.value;

						_this[key] = properties[key];
					}
				} catch (err) {
					_didIteratorError2 = true;
					_iteratorError2 = err;
				} finally {
					try {
						if (!_iteratorNormalCompletion2 && _iterator2.return) {
							_iterator2.return();
						}
					} finally {
						if (_didIteratorError2) {
							throw _iteratorError2;
						}
					}
				}
			}

			if (Error.captureStackTrace) {
				Error.captureStackTrace(_this, Custom_error);
			}
			return _this;
		}

		return Custom_error;
	}(Error);

	return Custom_error;
}
module.exports = exports['default'];
//# sourceMappingURL=errors.js.map